/*
 * radiomodul.h
 *
 * Created: 29.08.2013 14:32:04
 *  Author: roland
 */ 


#ifndef RADIOMODUL_H_
#define RADIOMODUL_H_

#define BANDLIMIT_LOW 87.5
#define BANDLIMIT_HIGH 108.0
#define NR_OF_STATIONS 10

#include "Sketch.h"
#include "lib/TEA5767.h"
class Radiomodul: public TEA5767{
	private:
	void saveAndSet();

	public:
	  int hilo_optimal (unsigned long freq);
	  bool timeout; 
	unsigned char buf[5];
	int activeSenderPlace;
	double activeSenderPlaceFreuqency; 
	void prevStation ();
	void nextStation ();
	void decFrequency(unsigned char *buf);
	void incFrequency(unsigned char *buf);
	void setActiveStation (int stationNr); //set the Station saved in EEPROM
	void clearAllStations();
	void set_frequency (uint16_t);
	void saveStationToEEPROM(); 
	void searchNextStation();
	void searchPrevStation();
	};



#endif /* RADIOMODUL_H_ */
extern Radiomodul Radio;  